<template>
    <li class="uk-card uk-card-small uk-card-default">
        <div uk-grid>
            <div class="uk-width-expand@m">
                <p>{{ conseil.libelle }}</p>
            </div>
            <div class="uk-width-auto@m">
                <span :class="getClassStatut()">{{ getLibelleStatut() }}</span>
                <button
                    v-if="modifiable"
                    class="uk-button uk-button-default button-conseil uk-margin-small-left"
                    @click="doAction()"
                >
                    {{ getLibelleAction() }}
                </button>
            </div>
        </div>
    </li>
</template>

<script lang="ts">
import Vue from 'vue';
import { Component, Prop } from 'vue-property-decorator';
import Axios from '@/auth/axiosAuth';

@Component
export default class Conseil extends Vue {
    @Prop() conseil: Record<string, any>;
    @Prop() modifiable: boolean;

    public getClassStatut() {
        let label = 'uk-label';
        if (this.isConseilValide()) {
            label += ' uk-label-success';
        } else if (this.isConseilPartage()) {
            label += ' uk-label-warning';
        }
        return label;
    }

    public getLibelleStatut() {
        if (this.isConseilValide()) {
            return 'Validé';
        }
        if (this.isConseilPartage()) {
            return 'En cours';
        }
        return 'Créé';
    }

    public getLibelleAction() {
        if (this.isConseilValide()) {
            return 'Invalider';
        }
        if (this.isConseilPartage()) {
            return 'Valider';
        }
        return 'Envoyer';
    }

    public doAction() {
        if (this.isConseilValide()) {
            Axios.post(
                'conseil/valide/' + this.conseil.id,
                response => (this.conseil.valide = false)
            );
        } else if (this.isConseilPartage()) {
            Axios.post(
                'conseil/valide/' + this.conseil.id,
                response => (this.conseil.valide = true)
            );
            this.conseil.valide = true;
        } else {
            Axios.post(
                'conseil/partage/' + this.conseil.id,
                response => (this.conseil.partageAvecEleve = true)
            );
        }
    }

    private isConseilValide() {
        return this.conseil.valide;
    }

    private isConseilPartage() {
        return this.conseil.partageAvecEleve;
    }
}
</script>

<style scoped>
.button-conseil {
    line-height: 25px;
}
</style>
